195bf1441ef8cb5acfabc22b35e1a7fa69155a28
[xfstests-dev.git] / tools / srcdiff
1 #!/usr/bin/perl -w
2 use strict;
3
4 # srcdiff is used to compare current user level code with the current
5 # kernel code and advise of any differences between files which are
6 # sharing some or all of their content.
7
8 # There are two classes of sharing which we will check - header files
9 # in the include directory, which must be exactly the same (use diff)
10 # and source files which contain routines which must be exactly the
11 # same (but the userland file is always a subset of the kernel file,
12 # and hence a more flexible mechanism to "diff" is required).
13
14 # NB: to cross check that srcdiff is finding all the functions in the
15 #     user source file, providing you have "mkproto" installed, you
16 #     can "cd cmd/xfsprogs/libxfs" and cut&paste this in a bourne shell:
17 #     $ for file in xfs_*.c; do
18 #     > mkproto -nps < $file | perl -ne '
19 #     > END { print "    $count\t- " }
20 #     > s/^.* (xfs\w+|\*xfs\w+|xlog\w+|\*xlog\w+) \(.*/\1/ && { $count++ }'
21 #     > echo $file
22 #     > done
23 # (compare this to "srcdiff | fgrep Total:") ... repeat for logprint.
24
25
26 die "WORKAREA not set" unless defined $ENV{'WORKAREA'};
27 chdir $ENV{'WORKAREA'};
28 my $xdiff = $ENV{'XDIFF'};
29 my $quiet=0;
30 my $usage=0;
31
32 foreach (@ARGV) {
33     if (/^-q$/) {
34         $quiet++;
35     } else {
36         print STDERR "Illegal option $_\n";
37         $usage++;
38     }
39 }
40
41 if ($usage) {
42     print STDERR "Usage: $0 [-q]\n";
43     exit 1;
44 }
45
46 my @difflist = qw(
47         xfs_ag.h  xfs_alloc.h  xfs_alloc_btree.h xfs_arch.h
48         xfs_attr_leaf.h  xfs_attr_sf.h  xfs_bit.h  xfs_bmap.h
49         xfs_bmap_btree.h  xfs_btree.h  xfs_buf_item.h
50         xfs_da_btree.h  xfs_dfrag.h  xfs_dinode.h  xfs_dir.h
51         xfs_dir2.h  xfs_dir2_block.h  xfs_dir2_data.h
52         xfs_dir2_leaf.h  xfs_dir2_node.h  xfs_dir2_sf.h
53         xfs_dir_leaf.h  xfs_dir_sf.h  xfs_dqblk.h  xfs_dquot_item.h
54         xfs_extfree_item.h  xfs_ialloc.h  xfs_imap.h
55         xfs_ialloc_btree.h  xfs_inode.h  xfs_inode_item.h
56         xfs_inum.h  xfs_log.h  xfs_log_priv.h  xfs_log_recover.h
57         xfs_mount.h  xfs_quota.h  xfs_rtalloc.h
58         xfs_sb.h  xfs_trans.h  xfs_trans_space.h  xfs_types.h
59 );
60
61 sub straightdiff {
62         my ( $file, $prefix1, $prefix2 ) = @_;
63
64         `diff $prefix1/$file $prefix2/$file >/dev/null 2>&1`;
65         if (!$quiet) {
66             print sprintf("\t%-35s ... ", $file);
67             if ($? != 0)        { print "FAILED\n"; }
68             else                { print "ok\n"; }
69         } elsif ($? != 0) { 
70                 printf("\t%-35s ... ", $file);
71                 print "FAILED\n"; 
72         }
73 }
74
75 print "\n=== Checking headers ===\n";
76 foreach (@difflist) {
77         straightdiff $_, 'cmd/xfsprogs/include', 'linux/fs/xfs';
78 }
79 straightdiff 'xfs_cred.h', 'cmd/xfsprogs/include', 'linux/fs/xfs/linux';
80 straightdiff 'xfs_fs.h', 'cmd/xfsprogs/include', 'linux/include/linux';
81 straightdiff 'attr_kern.h', 'cmd/attr/include', 'linux/include/linux';
82 straightdiff 'attributes.h', 'cmd/attr/include', 'linux/include/linux';
83 straightdiff 'dmapi_kern.h', 'cmd/dmapi/include', 'linux/include/linux';
84 straightdiff 'dmapi.h', 'cmd/dmapi/include', 'linux/include/linux';
85 straightdiff 'acl.h', 'cmd/acl/include', 'linux/include/linux';
86 straightdiff 'arch.h', 'cmd/xfsprogs/include', 'linux/fs/xfs_support';
87 straightdiff 'xqm.h', 'cmd/xfsprogs/include', 'linux/include/linux';
88
89
90 # setstate
91 # Implements a tri-state FSA, see comments for state transitions
92 #  (knows about the way the XFS kernel code is written, & makes
93 #   some assumptions so as to not need to parse generic C code).
94 # Accepts one line at a time from a source file, picking out the
95 #   function bodies so they can be subsequently compared.
96
97
98 my $line;       # line number in current source file
99 my $state;      # current FSA state
100 my $funcbody;   # current function body (contents)
101
102 sub setstate {
103         my ( $newline ) = @_;
104         $line++;
105
106         # - state 0:
107         #       if line looks like start of a function, transition to 1
108         #               & squirrel line away as line 1 of current function
109         if ($state == 0) {
110                 if ($newline =~ m/^[xfs|xlog]/) {
111                         $state = 1;
112                         $funcbody = $newline;
113                 }
114         }
115
116         # - state 1:
117         #       if line looks like start of a function, stay here
118         #               & squirrel line away as line 1 of current function
119         #       otherwise if line isn't start of function body,
120         #               squirrel line away as next line of current function
121         #               (args/..., but not sure this is a real function yet)
122         #       otherwise (start of function)
123         #               squirrel line away as next line of current function
124         #               transition to state 2
125         elsif ($state == 1) {
126                 if ($newline =~ m/^[xfs|xlog]/) {
127                         $funcbody = $newline;
128                 }
129                 elsif ($newline =~ m/^\{/) {
130                         $state = 2;
131                         $funcbody .= $newline;
132                 }
133         }
134
135         # - state 2:
136         #       if line looks like end of function body,
137         #               squirrel line away as last line of current function
138         #               tell someone we have a complete function ready
139         #               transition to state 0
140         #       otherwise
141         #               squirrel line away as next line of current function
142         elsif ($state == 2) {
143                 $funcbody .= $newline;
144                 if ($newline =~ m/^\}/) {
145                         $state = 0;
146                         return $funcbody;
147                 }
148         }
149
150         else {
151                 die "unknown state transition";
152         }
153         return undef;   # i.e. not at end of a function
154 }
155
156 sub listfuncs {
157         my ( $file ) = @_;
158         my @funcs;
159
160         $funcbody = '';
161         $state = $line = 0;
162
163         open(USER, "$file") || die "cannot open $file";
164         while (<USER>) {
165                 my $func = setstate($_);
166                 push @funcs, $func if (defined($func)); # store function away
167         }
168         close USER;
169         return @funcs;
170 }
171
172 sub hashfuncs {
173         my ( $file ) = @_;
174         my %funcs;
175
176         $funcbody = '';
177         $state = $line = 0;
178
179         open(KERN, "$file") || die "cannot open $file";
180         while (<KERN>) {
181                 my $func = setstate($_);
182                 if (defined($func)) {
183                         $func =~ m/^([xfs|xlog]\w+)\s*\(/;
184                         next unless defined($1);
185                         my $name = $1;
186                         if (defined($func)) {
187                                 $funcs{$name} = $func;  # store function away
188                         }
189                 }
190         }
191         close KERN;
192         return %funcs;
193 }
194
195 sub diffme {
196         my ( $sa, $sb ) = @_;
197
198         return unless defined($xdiff);
199
200         open(FILEA, "> /tmp/diff.user.$$") || die "cannot write to /tmp/diff.user.$$";
201         open(FILEB, "> /tmp/diff.kern.$$") || die "cannot write to /tmp/diff.kern.$$";
202         print FILEA $sa;
203         print FILEB $sb;
204         close FILEA;
205         close FILEB;
206         `$xdiff /tmp/diff.user.$$ /tmp/diff.kern.$$`;
207         unlink ("/tmp/diff.user.$$","/tmp/diff.kern.$$");
208 }
209
210 sub functiondiff {
211         my ( $file, $prefix1, $prefix2 ) = @_;
212         my $plural = '';
213         my $count = 0;
214         my $name;
215         my $found = 0;
216
217         print "\n=== Checking $file routines ===\n" unless ($quiet);
218
219         # iterate over user funcs, match up to kernel funcs
220         # 
221         my @user = listfuncs "$prefix1/$file";
222         my %kern = hashfuncs "$prefix2/$file";
223
224         foreach my $userfunc (@user) {
225                 
226                 $userfunc =~ m/^([xfs|xlog]\w+)\s*\(/;
227                 next unless (defined($1));
228                 $name = $1;
229                 $count++;
230
231                 if (exists($kern{$name})) {
232                         if ($userfunc ne $kern{$name}) {
233                                 print "\n=== $file routines ===\n"
234                                     if (!$found++ && $quiet);
235                                     
236                                 printf("\t%-35s ... ", $name);
237                                 print "FAILED\n";
238                                 diffme $userfunc, $kern{$name};
239                         }
240                         elsif (!$quiet) {
241                                 printf("\t%-35s ... ", $name);
242                                 print "ok\n";
243                         }
244                 }
245                 else {
246                         print "Cannot find kernel function $userfunc";
247                         print " in file $prefix2/$file\n";
248                 }
249         }
250         ($count != 1) && ( $plural = 's' );
251         print "( Total: $count routine$plural checked in $file )\n" unless ($quiet);
252 }
253
254 # cmd/xfsprogs/{libxfs,logprint}/* fs/xfs/*
255 my @funclist = qw(
256         xfs_alloc.c  xfs_alloc_btree.c  xfs_attr_leaf.c  xfs_bit.c
257         xfs_bmap.c  xfs_bmap_btree.c  xfs_btree.c  xfs_da_btree.c
258         xfs_dir.c  xfs_dir2.c  xfs_dir2_block.c  xfs_dir2_data.c
259         xfs_dir2_leaf.c  xfs_dir2_node.c  xfs_dir2_sf.c
260         xfs_dir_leaf.c  xfs_ialloc.c  xfs_ialloc_btree.c
261         xfs_inode.c  xfs_rtalloc.c  xfs_rtbit.c xfs_mount.c
262         xfs_trans.c
263 );
264
265 print "\n=== Checking libxfs code ===\n";
266 foreach (@funclist) {
267         functiondiff $_, 'cmd/xfsprogs/libxfs', 'linux/fs/xfs';
268 }
269 print "\n=== Checking logprint code ===\n";
270 functiondiff 'xfs_log_recover.c', 'cmd/xfsprogs/logprint', 'linux/fs/xfs';